# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2007, 2008, 2009. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

# import related classes
import sys;
from java.lang import *;
import java.io.File as File;
import re;
import shutil;
import os;
import os.path;

def isEmptyString(value):
    stringValue = String(value);                            
    if (stringValue.length() != 0):
        return "False";
    else:
        return "True";
#endDef

def getObjectArray(value):
    objectArray = [];
    
    # @todo: do we have a space problem here?
    stringValue = String(value);
    if (stringValue.length() != 0):
        objectArray = value.split(lineSeparator);
    
    return objectArray;
#endDef

def getCellContext():
    print ""
    cellContext = ""
    
    try:
        cellContext =  "/Cell:" + System.getProperty("local.cell");        
    except:
        print "Cannot get the cell context. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
    
    print "The value of cellContext is ", cellContext
    print ""
    return cellContext
#endDef

def getNodeContext():
    print ""
    nodeContext = ""
    
    try:
        nodeContext =  "/Node:" + System.getProperty("local.node");        
    except:
        print "Cannot get the node context. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
    
    print "The value of nodeContext is ", nodeContext
    print ""
    return nodeContext
#endDef

def getServerContext(serverName):
    print ""
    serverContext = ""
        
    if (isEmptyString(serverName) == "False"):
        serverContext =  "/Server:" + serverName;
    
    print "The value of serverContext is ", serverContext
    print ""
    return serverContext
#endDef

def getCellType():
    print ""
    cellType = ""
    
    try:
        print "getting cellID"
        cellID = AdminConfig.getid(getCellContext());
        print "cellID : ", cellID 
        
        print "getting cell type"
        cellType = AdminConfig.showAttribute(cellID, 'cellType');
        
    except:
        print "Cannot get the cell type. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
    
    print "The value of cellType is ", cellType
    print ""
    return cellType
#endDef


print "*************************************************************************************"
print "start: cross-component trace configuration migration"
print ""
try:
    cellType = getCellType();
    nodeID = AdminConfig.getid(getCellContext() + getNodeContext());
    servers = getObjectArray(AdminConfig.list("Server", nodeID));
    for server in servers:
        serverType = AdminConfig.showAttribute(server, "serverType");
        print "The value of serverType is ", serverType
        if (serverType == "APPLICATION_SERVER"):
            serverName = AdminConfig.showAttribute(server, "name");
            print "The value of serverName is ", serverName
            serverID = AdminConfig.getid(getCellContext() + getNodeContext() + getServerContext(serverName));
            
            coreServerExtensions =  getObjectArray(AdminConfig.list("CoreServerExtension", serverID));
            
            if (len(coreServerExtensions) != 1):
                continue;
            
            
            xctServices = getObjectArray(AdminConfig.list("XCTService", coreServerExtensions[0]));
            print "The value of xctServices is ", xctServices
            
            if (len(xctServices) > 0):
                level = AdminConfig.showAttribute(xctServices[0], "level")
                print "The value of level is ", level
                
                    
                xctServiceConfigs = getObjectArray(AdminConfig.list("XCTServiceConfig", coreServerExtensions[0]));
                print "The value of xctServiceConfigs is", xctServiceConfigs
                
                enabled = 'false'
                traceLevel = "off" 
                traceTarget = "FINE";               
                if (level == "enable"):
                    enabled = 'true'
                    traceLevel = "fine"
                elif (level == "enable with data snapshot"):
                    enabled = 'true'
                    traceLevel = "finer"
                
                
                if (len(xctServiceConfigs) == 0):
                    print ""
                    print "creating a XCTServiceConfig object."
                    xctServiceConfig = AdminConfig.create("XCTServiceConfig", coreServerExtensions[0], [['enabled', enabled], ['traceLevel', traceLevel], ['traceTarget', traceTarget]]);
                    print "The value of xctServiceConfig is", xctServiceConfig
                elif (cellType == 'STANDALONE'):
                    print ""
                    print "updating a XCTServiceConfig object."
                    xctServiceConfig = AdminConfig.modify(xctServiceConfigs[0], [['enabled', enabled], ['traceLevel', traceLevel], ['traceTarget', traceTarget]]);
                    print "updated a XCTServiceConfig object."
                else:
                    print ""
                    print "The XCTServiceConfig object already exists! and skipping the migration."
                  
    
                xctResourceConfigs  = getObjectArray(AdminConfig.list("XCTResourceConfig", coreServerExtensions[0]));
                print "The value of xctResourceConfigs is", xctResourceConfigs
                
                if (len(xctResourceConfigs) == 0):
                    print ""
                    print "creating a XCTResourceConfig object."
                    xctResourceConfig = AdminConfig.create("XCTResourceConfig", coreServerExtensions[0], [['snapshotCapacity', 0]]);
                    print "The value of xctResourceConfig is", xctResourceConfig
                elif (cellType == 'STANDALONE'):
                    print ""
                    print "updating a XCTResourceConfig object."
                    xctResourceConfig = AdminConfig.modify(xctResourceConfigs[0], [['snapshotCapacity', 0]]);
                    print "updated a XCTResourceConfig object."
                else:
                    print ""
                    print "The XCTResourceConfig object already exists! and skipping the migration."
                    
                AdminConfig.remove(xctServices[0])
    AdminConfig.save()
except:
    print "Cannot migrate cross-component trace configuration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
                
            
print 
print ""
print "end: cross-component trace configuration migration"
print "*************************************************************************************"